﻿;196x110
;120x90
;36x14


#TNminiWidth=196
#TNminiHeight=110

EnableExplicit

UsePNGImageDecoder()
UsePNGImageEncoder()
UseJPEGImageDecoder()
UseJPEGImageEncoder()
;UseTIFFImageDecoder()
;UseTGAImageDecoder()

#title="ThumbNailGen"
#build="Build "+#pb_editor_buildcount
#backnone=$FFFFFFF
#minwinh=670
#bordermax=10
Global iBack
Global can
Global ThumbNail$
Global gFont,gSize,gCan,gCol,gNoBack,gBack,gOutline,gFrom, gTo,gSave,gPre,gSuf,gSizeTxt,gExample,gLoadPic,gInfo
Global gBorder,gBorderTxt,gSettingsLoad,gSettingsSave,gZero,gZeroTxt,gAnchor,gLast,gFormat,gMiniCan
Global iBack,wBack,hBack
Global FontName.s="Arial",FontSize=80,PreText.s,SufText.s,LastText.s="End"
Global Border=2,RangeStart=1,RangeStop=50,Zero=3,Anchor=4,format=0
Global mRightClick

Define oldX,oldY
Define x,y
Define moved=#False

mRightClick=CreatePopupMenu(#PB_Any)
MenuItem(0,"left")
MenuItem(1,"center")
MenuItem(2,"right")
MenuBar()
MenuItem(3,"top")
MenuItem(4,"middle")
MenuItem(5,"bottom")

Global NewList    FaceName.s()
Define event
Global xText,yText,cText=RGB(127,127,127),bText=#backnone


XIncludeFile "about.pbi"

Define LogoAbout=CatchImage(#PB_Any,?logo)

About::Set("title", "About ...")
About::Set("logo", "", ImageID(LogoAbout))
About::Set("program", #title)
About::Set("version",#build)
About::Set("comment", FormatDate("%dd.%mm.%yyyy",#PB_Compiler_Date))
About::Set("website", "http://game.gpihome.eu/PureBasic/ThumbNail/")
about::set("website_name","gpihome.eu")
About::Set("copyright", "by GPI")
About::Set("license_mem","",?license)
About::Set("credits_mem","",?credits)

Global iClock=CatchImage(#PB_Any,?clock)

CompilerIf #PB_Compiler_OS=#PB_OS_Windows
  Procedure EnumFontFamExProc(*lpelfe.ENUMLOGFONTEX,*lpntme.NEWTEXTMETRICEX,FontType,lParam)
    Protected FaceName$
    Protected do
    
    FaceName$ = PeekS(@*lpelfe\elfFullName)
    
    ;   Select FontType
    ;     Case #TRUETYPE_FONTTYPE
    ;       Type$ + " [TT]"
    ;   EndSelect
    
    do=#True
    ForEach FaceName()
      If FaceName() = FaceName$ 
        do=#False
        Break
      EndIf
    Next
    
    If do
      AddElement(FaceName())   
      FaceName() = FaceName$
    EndIf
    
    ProcedureReturn #True
  EndProcedure
  
  Procedure ReadFontList(windowID)
    Protected lf.LOGFONT
    Protected hdc
    lf\lfCharset = #DEFAULT_CHARSET
    
    hdc = GetDC_(WindowID)
    EnumFontFamiliesEx_(hdc,lf,@EnumFontFamExProc(),0,0)
    ReleaseDC_(WindowID,hdc)
    
    SortList(FaceName(),#PB_Sort_NoCase)
    
  EndProcedure
  
CompilerElseIf #PB_Compiler_OS=#PB_OS_MacOS
  Procedure ReadFontList(windowId)
    Protected FontManager,AvailableFontFamilies,FontCount,i
    FontManager = CocoaMessage(0, 0, "NSFontManager sharedFontManager")
    AvailableFontFamilies = CocoaMessage(0, FontManager, "availableFontFamilies")
    FontCount = CocoaMessage(0, AvailableFontFamilies, "count")
    
    i = 0
    While i < FontCount
      AddElement(FaceName())   
      FaceName() =  PeekS(CocoaMessage(0, CocoaMessage(0, AvailableFontFamilies, "objectAtIndex:", i), "UTF8String"), -1, #PB_UTF8)
      i + 1
    Wend
    SortList(FaceName(),#PB_Sort_NoCase)
    
  EndProcedure
CompilerEndIf



Macro quote
  "
EndMacro
Macro RefW(a)
  WritePreferenceInteger(quote#a#quote,a)
EndMacro
Macro RefR(a)
  a=ReadPreferenceInteger(quote#a#quote,a)
EndMacro
Macro RefWs(a)
  WritePreferenceString(quote#a#quote,a)
EndMacro
Macro RefRs(a)
  a=ReadPreferenceString(quote#a#quote,a)
EndMacro

Procedure LoadPic()
  Protected a$
  a$=OpenFileRequester(#title,ThumbNail$,"Pics|*.jpg;*.png;*.tga;*.tif;*.bmp|all|*.*",0)
  
  If a$=""
    ProcedureReturn
  EndIf
  ThumbNail$=a$
  
  If iback
    FreeImage(iback)
  EndIf
  
  iBack=LoadImage(#PB_Any,ThumbNail$)
  
  If iback=0
    ProcedureReturn
  EndIf
  
  wBack=ImageWidth(iBack)
  hBack=ImageHeight(iBack)
  
  
EndProcedure

Macro ifold(a)
  Static old#a
  If old#a<>a
    old#a=a
    do=#True
  EndIf
EndMacro
Procedure DrawPic(text$="",ignorezero=#False)
  Protected y,x
  Protected xx,yy
  Protected do
  Protected mini
  Static font
  Static oldfont$,oldsize
  
  
  If text$=""
    x=GetGadgetState(gExample)
    If x<200
      text$=Str(x)
    Else
      text$=LastText:ignorezero=#True
    EndIf    
  EndIf
  
  If ignorezero=#False  
    If zero>0 
      text$=Right("0000000000000000000000"+text$,zero)
    EndIf
    
    text$=PreText+text$+SufText
  EndIf
  
  
  If font=0 Or FontName<>oldfont$ Or fontSize<>oldsize
    If font
      FreeFont(font)
    EndIf
    
    font=LoadFont(#PB_Any,FontName,FontSize,#PB_Font_HighQuality)
    oldfont$=FontName: oldsize=FontSize
    do=#True
  EndIf
  
  ifold(iBack)
  ifold(wBack)
  ifold(hBack)
  ifold(xtext)
  ifold(ytext)
  ifold(text$)
  ifold(btext)
  ifold(ctext)
  ifold(border)
  ifold(Anchor)
  
  If do=#False
    ProcedureReturn
  EndIf
  
  StartDrawing(CanvasOutput(gCan))
  DrawImage(ImageID(iBack),0,0)
  DrawingFont(FontID(font))
  
  xx=anchor%3
  yy=anchor/3
  Select xx
    Case 0
      x=0
    Case 1
      x=TextWidth(text$)/2
    Case 2
      x=TextWidth(text$)
  EndSelect
  Select yy
    Case 0
      y=0
    Case 1
      y=TextHeight(text$)/2
    Case 2
      y=TextHeight(text$)
  EndSelect
  
  If bText=#backnone
    ;     
    ;     DrawingMode(#PB_2DDrawing_AlphaBlend  )
    ;     DrawText(xText-x-1,yText-y,text$,RGBA(Red(cText),Green(cText),Blue(cText),64),RGBA(0,0,0,0))
    ;     DrawText(xText-x+1,yText-y,text$,RGBA(Red(cText),Green(cText),Blue(cText),64),RGBA(0,0,0,0))
    ;     DrawText(xText-x,yText-y-1,text$,RGBA(Red(cText),Green(cText),Blue(cText),64),RGBA(0,0,0,0))
    ;     DrawText(xText-x,yText-y+1,text$,RGBA(Red(cText),Green(cText),Blue(cText),64),RGBA(0,0,0,0))
    ;     
    DrawingMode(#PB_2DDrawing_Transparent )
    DrawText(xText-x,yText-y,text$,cText)
  ElseIf bText<0
    DrawingMode(#PB_2DDrawing_Transparent )
    For xx=-Border To Border
      For yy=-Border To Border
        DrawText(xText-x+xx,yText-y+yy,text$,-bText-1)
      Next
    Next
    DrawText(xText-x,yText-y,text$,cText)
    
  Else
    DrawingMode(#PB_2DDrawing_Default  )
    Box(xText-x-border,yText-y-border,TextWidth(text$)+border*2,TextHeight(text$)+border*2,bText)
    
    DrawingMode(#PB_2DDrawing_Default  )
    DrawText(xText-x,yText-y,text$,cText,bText)
  EndIf
  
  mini=GrabDrawingImage(#PB_Any,0,0,wBack,hBack)
  
  StopDrawing()
  
  ;ResizeImage(mini,#TNminiWidth,#TNminiHeight)
  
  StartDrawing(CanvasOutput(gMiniCan))
  DrawImage(ImageID(mini),0,0,#TNminiWidth,#TNminiHeight)
  DrawImage(ImageID(iClock),#TNminiWidth-2-ImageWidth(iclock),#TNminiHeight-2-ImageHeight(iclock))
  StopDrawing()
  
  FreeImage(mini)
  
EndProcedure
Procedure ResizeWin()
  Protected h,w
  Protected dy,dx,x,y
  
  
  w=250+10+10+10+wBack
  h=hBack+10+10
  If h<#minwinh
    h=#minwinh
  EndIf
  
  dx=(WindowWidth(0) - w)/2
  dy=(WindowHeight(0) -h)/2
  x=WindowX(0)+dx
  y=WindowY(0)+dy
  
  ResizeWindow(0,x,y,w,h)
  ResizeGadget(gCan,#PB_Ignore,#PB_Ignore,wBack,hBack)
  
  ResizeGadget(gSave,#PB_Ignore,h-30,#PB_Ignore,#PB_Ignore)
  ResizeGadget(gInfo,#PB_Ignore,h-30,#PB_Ignore,#PB_Ignore)
  DrawPic()
EndProcedure

Procedure SaveSettings(file.s)
  CreatePreferences(file.s)
  RefW(xText)
  RefW(yText)
  RefW(cText)
  RefW(bText)
  RefWs(FontName)
  RefW(FontSize)
  RefWs(PreText)
  RefWs(SufText)
  RefW(Border)
  RefW(RangeStart)
  RefW(RangeStop)
  refW(zero)
  RefW(Anchor)
  RefWs(LastText)
  RefW(Format)
  ClosePreferences()
EndProcedure
Procedure LoadSettings(file.s)
  OpenPreferences(file.s)
  RefR(xText)
  RefR(yText)
  RefR(cText)
  RefR(bText)
  RefRs(FontName)
  RefR(FontSize)
  RefRs(PreText)
  RefRs(SufText)
  RefR(Border)
  RefR(RangeStart)
  RefR(RangeStop)
  RefR(zero)
  RefR(Anchor)
  RefRs(LastText)
  RefR(Format)
  ClosePreferences()
  
  SetGadgetState(gFormat,format)
  SetGadgetText(gLast,LastText)
  
  SetGadgetText(gFont,FontName)
  SetGadgetState(gSize,FontSize)
  SetGadgetText(gSizeTxt,Str(FontSize))
  SetGadgetText(gPre,PreText)
  SetGadgetText(gSuf,SufText)
  
  SetGadgetState(gNoBack,0)
  SetGadgetState(gCol,0)
  SetGadgetState(gOutline,0)
  
  If bText=#backnone
    SetGadgetState(gNoBack,#True)
  ElseIf btext<0
    SetGadgetState(gOutline,#True)
  Else
    SetGadgetState(gBack,#True)
  EndIf
  
  SetGadgetState(gBorder,Border)
  SetGadgetText(gBorderTxt,Str(Border))
  
  SetGadgetState(gFrom,RangeStart)
  SetGadgetState(gTo,RangeStop)
  SetGadgetState(gZero,Zero)
  SetGadgetText(gZeroTxt,Str(zero))
  SetGadgetState(gAnchor,Anchor)
  
  DrawPic()
  
EndProcedure



LoadPic()
If iback=0
  End
EndIf


xText=wBack/2
yText=hBack/2


;- Fenster erstellen
Define y
OpenWindow(0,0,0,250+10+10+10+wback,hback+20,#Title+" ("+#build+")",#PB_Window_SystemMenu|#PB_Window_ScreenCentered)
y=10

gLoadPic=ButtonGadget(#PB_Any,10,y,250,20,"Load Image"):y+30


TextGadget(#PB_Any,10,y, 50,20,"Font")
gFont=ComboBoxGadget(#PB_Any,60,y,200,20):y+30
gSize=TrackBarGadget(#PB_Any,60,y,165,30,8,200)
gSizeTxt=TextGadget(#PB_Any,60+165,y,40,20,"20",#PB_Text_Center):y+40
gCol=ButtonGadget(#PB_Any,60,y,200,20,"Color (shift+click=pick)"):y+30

TextGadget(#PB_Any,10,y, 50,20,"Back")
gNoBack=OptionGadget(#PB_Any,60,y,200,20,"None"):y+20
gBack=OptionGadget(#PB_Any,60,y,200,20,"Color (ctrl+click=pick)"):y+20
gOutline=OptionGadget(#PB_Any,60,y,200,20,"Outline (alt+click=pick)"):y+30

TextGadget(#PB_Any,10,y, 50,20,"Border")
gBorder=TrackBarGadget(#PB_Any,60,y,175,30,0,#bordermax,#PB_TrackBar_Ticks)
gBorderTxt=TextGadget(#PB_Any,60+175,y,25,20,"20",#PB_Text_Center):y+40

TextGadget(#PB_Any,10,y, 50,20,"Anchor")
gAnchor=ComboBoxGadget(#PB_Any,60,y,200,20):y+30


TextGadget(#PB_Any,10,y, 50,20,"Range")
gfrom=SpinGadget(#PB_Any, 60,y,75,20     ,0,99999,#PB_Spin_Numeric)
TextGadget(#PB_Any,60+75,y, 50,20,"to",#PB_Text_Center)
gTo  =SpinGadget(#PB_Any,60+75+50,y,75,20,0,99999,#PB_Spin_Numeric):y+30

TextGadget(#PB_Any,10,y, 50,40,"Fixed"+Chr(10)+"Size")
gZero=TrackBarGadget(#PB_Any,60,y,175,30,0,5,#PB_TrackBar_Ticks)
gZeroTxt=TextGadget(#PB_Any,60+175,y,25,20,"20",#PB_Text_Center):y+40

TextGadget(#PB_Any,10,y, 50,40,"Pre/"+Chr(10)+"Suffix")
gPre =StringGadget(#PB_Any,60,y,75,20,"")
TextGadget(#PB_Any,60+75,y, 50,20,"000",#PB_Text_Center)
gSuf =StringGadget(#PB_Any,60+75+50,y,75,20,""):y+30

TextGadget(#PB_Any,10,y, 50,20,"Last")
gLast =StringGadget(#PB_Any,60,y,200,20,""):y+30

TextGadget(#PB_Any,10,y, 50,20,"Example")
gExample=TrackBarGadget(#PB_Any,60,y,250-50,30,0,200):y+40

TextGadget(#PB_Any,10,y, 50,20,"Format")
gFormat=ComboBoxGadget(#PB_Any,60,y,200,20):y+30

TextGadget(#PB_Any,10,y, 50,20,"Settings")
gSettingsLoad=ButtonGadget(#PB_Any,60,y,95,20,"Load")
gSettingsSave=ButtonGadget(#PB_Any,60+95+10,y,95,20,"Save"):y+30

gMiniCan=CanvasGadget(#PB_Any,10 +(250-#TNminiWidth)/2,y,#TNminiWidth,#TNminiHeight):y+#TNminiHeight+10

Debug y+20+10+10


gSave = ButtonGadget(#PB_Any,10,WindowHeight(0)-30,220,20,"Create")
ginfo =ButtonGadget(#PB_Any,230,WindowHeight(0)-30,30,20,"?")

gCan=CanvasGadget(#PB_Any,250+10+10,10,wBack,hBack)

ReadFontList(WindowID(0))

ForEach FaceName()
  AddGadgetItem(gFont,-1,FaceName())
Next

FreeList(FaceName())

AddGadgetItem(gFormat,-1,"PNG (Portable Network Graphic)")
AddGadgetItem(gFormat,-1,"JPEG 70% (Joint Picture Expert Group)")
AddGadgetItem(gFormat,-1,"JPEG 80% (Joint Picture Expert Group)")
AddGadgetItem(gFormat,-1,"JPEG 90% (Joint Picture Expert Group)")
AddGadgetItem(gFormat,-1,"JPEG 100% (Joint Picture Expert Group)")

AddGadgetItem(gAnchor,-1,"Left Top")
AddGadgetItem(gAnchor,-1,"Center Top")
AddGadgetItem(gAnchor,-1,"Right Top")

AddGadgetItem(gAnchor,-1,"Left Middle")
AddGadgetItem(gAnchor,-1,"Center Middle")
AddGadgetItem(gAnchor,-1,"Right Middle")

AddGadgetItem(gAnchor,-1,"Left Bottom")
AddGadgetItem(gAnchor,-1,"Center Bottom")
AddGadgetItem(gAnchor,-1,"Right Bottom")


ResizeWin()

LoadSettings(#title+".ini")

DrawPic()

Repeat
  event=WaitWindowEvent()
  
  Select event
    Case #PB_Event_CloseWindow
      Break
    Case #PB_Event_Menu
      Select EventMenu()
        Case 0:xtext=0
        Case 1:xtext=wBack/2
        Case 2:xtext=wBack-1
        Case 3:ytext=0
        Case 4:ytext=hBack/2
        Case 5:ytext=hBack-1
      EndSelect
      DrawPic()
      
    Case #PB_Event_Gadget
      Select EventGadget()   
        Case gAnchor
          anchor=GetGadgetState(gAnchor)
          DrawPic()
          
        Case gSettingsSave
          Define a$
          a$=SaveFileRequester(#title,"","Settings|*.ini|all|*.*",0)
          
          If a$<>""
            If GetExtensionPart(a$)=""
              a$+".ini"
            EndIf
            
            SaveSettings(a$)
          EndIf
        Case gSettingsLoad
          Define a$
          a$=OpenFileRequester(#title,"","Settings|*.ini|all|*.*",0)
          If a$<>""
            LoadSettings(a$)
            DrawPic()
          EndIf
          
        Case gFormat
          format=GetGadgetState(gFormat)
          
        Case gNoBack
          bText=#backnone
          DrawPic()
          
        Case gBack
          If btext=#backnone
            btext=0
          ElseIf btext<0
            btext=-btext-1
          EndIf
          
          bText=ColorRequester(bText)
          DrawPic()
          
        Case gOutline
          If btext=#backnone
            btext=0
          ElseIf btext<0
            btext=-btext-1
          EndIf
          
          bText=-ColorRequester(bText)-1
          DrawPic()
          
        Case gCol
          cText=ColorRequester(cText)
          DrawPic()
          
        Case gBorder
          Border=GetGadgetState(gBorder)
          SetGadgetText(gBorderTxt,Str(Border))
          DrawPic()
          
        Case gZero
          zero=GetGadgetState(gZero)
          SetGadgetText(gZeroTxt,Str(zero))
          DrawPic()
          
        Case gSize
          FontSize=GetGadgetState(gSize)
          SetGadgetText(gSizeTxt,Str(FontSize))
          DrawPic()
          
        Case gFont
          FontName=GetGadgetText(gFont):
          DrawPic()
          
        Case gPre
          PreText=GetGadgetText(gPre)
          DrawPic()
          
        Case gSuf
          SufText=GetGadgetText(gSuf)
          DrawPic()
          
        Case gExample
          DrawPic()
          
        Case gFrom
          RangeStart=GetGadgetState(gFrom)
        Case gTo
          RangeStop=GetGadgetState(gTo)
          
        Case gLast
          LastText=GetGadgetText(gLast)
          DrawPic()
          
        Case gInfo
          ;MessageRequester(#title,"by GPI "+FormatDate("%dd.%mm.%yyyy",#PB_Compiler_Date)+" Build "+Str(#pb_editor_buildcount)+
          ;                        Chr(10)+"http://game.gpihome.eu/PureBasic/ThumbNail/")
          About::Show(WindowID(0))
          
        Case gSave;-create
          Define i,outimg
          Define Filename.s,a$
          
          filename=Left(thumbnail$,Len(ThumbNail$)-Len(GetExtensionPart(ThumbNail$)))
          Debug Filename
          
          For i=RangeStart To RangeStop+1
            If i<=RangeStop
              DrawPic(Str(i))
              a$=Filename+Right("0000000"+Str(i),5)
            Else
              DrawPic(LastText,#True)
              a$=Filename+LastText
            EndIf
            StartDrawing(CanvasOutput(gCan))
            outimg=GrabDrawingImage(#PB_Any,0,0,wBack,hBack)
            Select format
              Case 0:SaveImage(outimg,a$+".png",#PB_ImagePlugin_PNG)
              Case 1:SaveImage(outimg,a$+".jpg",#PB_ImagePlugin_JPEG,7)
              Case 2:SaveImage(outimg,a$+".jpg",#PB_ImagePlugin_JPEG,8)
              Case 3:SaveImage(outimg,a$+".jpg",#PB_ImagePlugin_JPEG,9)
              Case 4:SaveImage(outimg,a$+".jpg",#PB_ImagePlugin_JPEG,10)
            EndSelect
            FreeImage(outimg)
            StopDrawing()
            
            While WindowEvent():Wend
          Next                   
          DrawPic()
          
        Case gLoadPic
          LoadPic()
          
          If iBack=0
            Break
          EndIf
          ResizeWin()
          
        Case gCan
          
          Select EventType()
            Case #PB_EventType_MouseWheel
              If GetGadgetAttribute(gcan,#PB_Canvas_Modifiers )& (#PB_Canvas_Control|#PB_Canvas_Alt)
                Border+GetGadgetAttribute(gcan,#PB_Canvas_WheelDelta  )
                If border>#bordermax : border=#bordermax:ElseIf border<0:border=0:EndIf
                SetGadgetState(gBorder,Border)
                SetGadgetText(gBorderTxt,Str(Border))
              Else                
                FontSize+GetGadgetAttribute(gcan,#PB_Canvas_WheelDelta  )
                SetGadgetState(gSize,FontSize)
                SetGadgetText(gSizeTxt,Str(FontSize))
              EndIf
              DrawPic()
              
            Case #PB_EventType_RightButtonDown
              oldx=GetGadgetAttribute(gCan,#PB_Canvas_MouseX)
              oldy=GetGadgetAttribute(gCan,#PB_Canvas_MouseY)
              moved=#False
              Debug "DOWN:"+moved
              
            Case #PB_EventType_RightButtonUp
              Debug "UP:"+moved
              If moved=#False
                DisplayPopupMenu(mRightClick,WindowID(0))
              EndIf
              
            Case #PB_EventType_LeftButtonDown,#PB_EventType_MouseMove
              x=GetGadgetAttribute(gCan,#PB_Canvas_MouseX)
              If x<0:x=0:ElseIf x>=wback:x=wback-1:EndIf
              y=GetGadgetAttribute(gCan,#PB_Canvas_MouseY)
              If y<0:y=0:ElseIf y>=hback:y=hback-1:EndIf
              
              If GetGadgetAttribute(gCan,#PB_Canvas_Buttons )&#PB_Canvas_LeftButton
                If GetGadgetAttribute(gcan,#PB_Canvas_Modifiers )&#PB_Canvas_Shift
                  StartDrawing(CanvasOutput(gCan))
                  cText=Point(x,y)
                  StopDrawing()
                ElseIf GetGadgetAttribute(gcan,#PB_Canvas_Modifiers )& #PB_Canvas_Control
                  StartDrawing(CanvasOutput(gCan))
                  
                  bText=Point(x,y)                  
                  StopDrawing()
                  SetGadgetState(gBack,#True)                  
                ElseIf GetGadgetAttribute(gcan,#PB_Canvas_Modifiers )& #PB_Canvas_Alt
                  StartDrawing(CanvasOutput(gCan))
                  bText=-Point(x,y)-1                  
                  StopDrawing()
                  SetGadgetState(gOutline,#True)
                Else                  
                  xText=x
                  yText=y
                EndIf
                DrawPic()
              ElseIf GetGadgetAttribute(gCan,#PB_Canvas_Buttons )&#PB_Canvas_RightButton
                xText+(x-oldx)
                yText+(y-oldy)
                oldx=x
                oldy=y
                moved=#True
                Debug "moved:"+moved
                DrawPic()                  
              EndIf
              
              
            Case #PB_EventType_RightClick
              
              
          EndSelect
      EndSelect
      
  EndSelect
  
ForEver

SaveSettings(#title+".ini")

DataSection
  logo:
  IncludeBinary "logo.png"
  clock:
  IncludeBinary "clock.png"
  license:
  IncludeBinary "Licenses_PBLibraries.txt"
  Data.i 0
  credits:
  IncludeBinary "Credits.txt"
  Data.i 0
EndDataSection
; IDE Options = PureBasic 5.42 LTS (Windows - x64)
; CursorPosition = 450
; FirstLine = 430
; Folding = ---
; EnableUnicode
; EnableXP
; UseIcon = 1463608515_folder3.ico
; Executable = ..\ThumbNailGen.exe
; CurrentDirectory = ..\
; EnableCompileCount = 264
; EnableBuildCount = 15
; EnableExeConstant